#!/usr/bin/python
# -*- coding: UTF-8 -*-

##载入模块, 使用shell命令
import subprocess 
import csv
 
#print ("python脚本开始")
import sys
input_fasta=sys.argv[1]
genome=sys.argv[2]
input_type=sys.argv[3]
all_hit=sys.argv[4]
#print (input_fasta)
#print (genome)
#print (input_type)


 #生成随机数
import timeit

a_str = (str(timeit.default_timer())).replace(".","")

inputfile="tmp_input_"+a_str

outputfile="tmp_output_"+a_str

with open (inputfile,'w') as f:
    f.write (">"+"\n")    
    f.write (input_fasta+"\n")
    f.close()
    
#开始执行blast
#print ("blast")
#subprocess.run(["ls"],shell=True)

if input_type in "prot":
    if all_hit=="1":
        cmd1="/home/lain/miniconda3/bin/blastp -query "+inputfile+" -db /www/wwwroot/www.winberige.cc/data/"+genome+"/"+genome+".prot -evalue 0.001 -outfmt 6 -num_threads 2 -out "+outputfile
    ##貌似改成输出一个最佳速度没有提升多少
    elif all_hit=="-1":
        cmd1="/home/lain/miniconda3/bin/blastp -query "+inputfile+" -db /www/wwwroot/www.winberige.cc/data/"+genome+"/"+genome+".prot -evalue 0.001 -outfmt 6 -num_threads 2 -max_target_seqs 1 -out "+outputfile
    else:
        cmd1="/home/lain/miniconda3/bin/blastp -query "+inputfile+" -db /www/wwwroot/www.winberige.cc/data/"+genome+"/"+genome+".prot -evalue 0.001 -outfmt 6 -num_threads 2 -max_target_seqs 10 -out "+outputfile        
        
    #print (cmd1)
    subprocess.run([cmd1],shell=True)
    
else:
    if all_hit=="1":
        cmd2="/home/lain/miniconda3/bin/blastn -query "+inputfile+" -db /www/wwwroot/www.winberige.cc/data/"+genome+"/"+genome+".mRNA -evalue 0.001 -outfmt 6 -num_threads 2  -strand plus  -out "+outputfile
    elif all_hit=="-1":
        cmd2="/home/lain/miniconda3/bin/blastn -query "+inputfile+" -db /www/wwwroot/www.winberige.cc/data/"+genome+"/"+genome+".mRNA -evalue 0.001 -outfmt 6 -num_threads 2 -max_target_seqs 1 -strand plus  -out "+outputfile 
    else:
        cmd2="/home/lain/miniconda3/bin/blastn -query "+inputfile+" -db /www/wwwroot/www.winberige.cc/data/"+genome+"/"+genome+".mRNA -evalue 0.001 -outfmt 6 -num_threads 2 -max_target_seqs 10 -strand plus  -out "+outputfile         
        
    #print (cmd2)   
    subprocess.run([cmd2],shell=True)
#subprocess.run(["/home/lain/miniconda3/bin/conda -h"],shell=True)
subprocess.run(["rm "+inputfile],shell=True) 


#print ("快结束了")
	##echo ("genome".'\t'."geneid".'\t'."transcriptid".'\t'.'pident'.'\t'."length".'\t'."mismatch".'\t'."gapopen".'\t'."evalue".'\t'."bitscore");
with open (outputfile,'r') as f:
    for line in f.readlines():
        arr=line.split('\t')
        
        if (1>2):   #这里是我写错了吗？？？？
            eachline=genome+'_||_'+"NA"+'_||_ _||_ _||_ _||_ _||_ _||_ _||_ _||_ _||_ _||_ _||_ _;;_'
            print (eachline)
        else:
            #print ("查询数据库")
            #查询基因名用python调用数据库
            import pymysql
            db=pymysql.connect(host="localhost",database='base_1',user='root',password='123456a')
            #通过连接对象获取游标
            cursor = db.cursor()
            #使用execute()方法执行 SQL 查询
            #检索基因名字
            rnaid=arr[1]
            #print ("RNAAAAAAAAAAAAA",rnaid)
            sql='select geneid from rnaid_geneid_genome where rnaid = "'+rnaid+'" and genome= "'+genome+'";'
            #print(sql)
            cursor.execute(sql)
            geneid = (cursor.fetchall())[0][0]
            #print(geneid)
            #print ("<br>")
            eachline=genome+'_||_'+geneid+'_||_'+arr[1]+'_||_'+arr[10]+'_||_'+arr[11]+'_||_'+arr[2]+'_||_'+arr[3]+'_||_'+arr[4]+'_||_'+arr[5]+'_||_'+arr[6]+'_||_'+arr[7]+'_||_'+arr[8]+'_||_'+arr[9]+'_;;_'
            eachline2=str(eachline.strip())
            print (eachline2)

    
subprocess.run(["rm "+outputfile],shell=True)        
      
      
      
      
      
      
      
      
      
      
      
      
      
        
        
        
    #
    #subprocess.run(["ls"],shell=True)
    #print("echo <br>")

    #print("echo <br>")
    #subprocess.run(["/home/lain/miniconda3/bin/conda -h"],shell=True)